/*
 * MBIC_Bootloader.h
 *
 *  Created on: 2020. 5. 18.
 *      Author: parkyj
 */

#ifndef MBIC_BOOTLOADER_H_
#define MBIC_BOOTLOADER_H_

typedef enum{
  MBIC_Notice_REQ = 0x10,
  MBIC_Download_DATA_REQ,
  MBIC_Download_Confirm_REQ,
  MBIC_Complete_Notice_REQ_REQ,
  MBIC_Reboot_Notice_REQ,
}MBIC_Download_Req_L;
typedef enum{
  MBIC_Notice_RSP = 0x90,
  MBIC_Download_DATA_RSP,
  MBIC_Download_Confirm_RSP,
  MBIC_Complete_Notice_RSP,
  MBIC_Reboot_Notice_RSP,
}MBIC_Download_Rsp_L;


typedef enum{
	MBIC_PREAMBLE_0 = 0,
	MBIC_PREAMBLE_1,
	MBIC_PREAMBLE_2,
	MBIC_PREAMBLE_3,
	MBIC_SUBUID_0,
	MBIC_SUBUID_1,
	MBIC_RCODE_0,
	MBIC_TRID_0,
	MBIC_TRID_1,
	MBIC_SEQSUM_0, // 9Index
	
	MBIC_TTL_0, //10 INDEX
	MBIC_TIME_0,
	MBIC_TIME_1,
	MBIC_TIME_2,
	MBIC_TIME_3,
	MBIC_TIME_4,
	MBIC_TIME_5,
	MBIC_ERRRESPONSE_0,
	MBIC_CMD_0,
	
	MBIC_LENGTH_0, // 19INDEX
	MBIC_LENGTH_1, // 20

	MBIC_HEADERCHECKSUM_0,
	MBIC_PAYLOADSTART,
    /*
	 * PayLoadSTART
	 */
}MBICProt_st;

#endif /* MBIC_BOOTLOADER_H_ */
